%define major 11
%define libname %mklibname gcrypt %{major}
%define develname %mklibname gcrypt -d

# disable tests by default, no /dev/random feed, no joy
%define do_check 1
%{expand: %{?_with_check: %%global do_check 1}}

Summary:	GNU Cryptographic library
Name:		libgcrypt
Version:	1.5.4
%define subrel	2
Release:	%mkrel 5
License:	LGPLv2+
Group:		System/Libraries
Url:		http://www.gnupg.org/
# don't convert to bzip2, since we ship archive signature
Source0:	ftp://ftp.gnupg.org/gcrypt/libgcrypt/%{name}-%{version}.tar.bz2
Source1:	ftp://ftp.gnupg.org/gcrypt/libgcrypt/%{name}-%{version}.tar.bz2.sig
Patch1:		libgcrypt-1.2.0-libdir.patch
Patch2:		libgcrypt-1.5.4-CVE-2014-3591.patch
Patch3:		libgcrypt-1.5.4-CVE-2015-0837.patch
Patch4:		0001-rsa-Add-verify-after-sign-to-avoid-Lenstra-s-CRT-att.patch
Patch5:		libgcrypt-1.5.4-CVE-2015-7511.patch
BuildRequires:	libgpg-error-devel >= 0.5
BuildRequires:	pth-devel

%description
Libgcrypt is a general purpose cryptographic library
based on the code from GNU Privacy Guard.  It provides functions for all
cryptograhic building blocks: symmetric ciphers
(AES,DES,Blowfish,CAST5,Twofish,Arcfour), hash algorithms (MD5,
RIPE-MD160, SHA-1, TIGER-192), MACs (HMAC for all hash algorithms),
public key algorithms (RSA, ElGamal, DSA), large integer functions,
random numbers and a lot of supporting functions.

%package -n %{libname}
Summary:	GNU Cryptographic library
Group:		System/Libraries
Provides:	%{name} = %{version}-%{release}

%description -n %{libname}
Libgcrypt is a general purpose cryptographic library
based on the code from GNU Privacy Guard.  It provides functions for all
cryptograhic building blocks: symmetric ciphers
(AES,DES,Blowfish,CAST5,Twofish,Arcfour), hash algorithms (MD5,
RIPE-MD160, SHA-1, TIGER-192), MACs (HMAC for all hash algorithms),
public key algorithms (RSA, ElGamal, DSA), large integer functions,
random numbers and a lot of supporting functions.

%package -n %{develname}
Summary:	Development files for GNU cryptographic library
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%mklibname -d gcrypt 11

%description -n %{develname}
Libgcrypt is a general purpose cryptographic library
based on the code from GNU Privacy Guard.
This package contains files needed to develop
applications using libgcrypt. ( For example Ägypten project )

%prep
%setup -q
%patch1 -p1 -b .libdir
%patch2 -p1 -b .CVE-2014-3591
%patch3 -p1 -b .CVE-2015-0837
%patch4 -p1
%patch5 -p1 -b .CVE-2015-7511

%build
%configure2_5x --disable-static \
	--disable-dev-random \
	--enable-random-daemon \
	--enable-m-guard
%make

%check
%if %{do_check}
make check
%endif

%install
%makeinstall_std

find %{buildroot} -name '*.la' -delete

mv $RPM_BUILD_ROOT/%{_sbindir}/gcryptrnd $RPM_BUILD_ROOT/%{_bindir}/gcryptrnd
%multiarch_binaries $RPM_BUILD_ROOT/%{_bindir}/gcryptrnd

%post -n %{develname}
%_install_info %{name}.info

%postun -n %{develname}
%_remove_install_info %{name}.info

%files -n %{libname}
%doc AUTHORS README NEWS THANKS TODO
%multiarch %{multiarch_bindir}/gcryptrnd
%{_libdir}/lib*.so.%{major}
%{_libdir}/lib*.so.%{major}.*

%files -n %{develname}
%doc ChangeLog README.*
%{_bindir}/*
%{_includedir}/*.h
%{_libdir}/lib*.so
%{_datadir}/aclocal/*
%{_infodir}/gcrypt.info*


%changelog
* Fri Feb 12 2016 luigiwalser <luigiwalser> 1.5.4-5.2.mga5
+ Revision: 958838
- add patch from upstream via gentoo to fix CVE-2015-7511
- add patch from opensuse to fix issue related to CVE-2015-5738

* Wed Apr 01 2015 luigiwalser <luigiwalser> 1.5.4-5.mga5
+ Revision: 819552
- add patch from ubuntu to fix CVE-2015-0837

* Fri Mar 06 2015 luigiwalser <luigiwalser> 1.5.4-4.mga5
+ Revision: 817945
- add upstream patch to fix CVE-2014-3591

* Wed Oct 15 2014 umeabot <umeabot> 1.5.4-3.mga5
+ Revision: 744285
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.5.4-2.mga5
+ Revision: 681474
- Mageia 5 Mass Rebuild

* Mon Aug 11 2014 luigiwalser <luigiwalser> 1.5.4-1.mga5
+ Revision: 661714
- 1.5.4 (fixes elgamal side-channel attack)

* Sat Oct 19 2013 umeabot <umeabot> 1.5.3-2.mga4
+ Revision: 530654
- Mageia 4 Mass Rebuild

* Sat Jul 27 2013 boklm <boklm> 1.5.3-1.mga4
+ Revision: 458790
- Version 1.5.3 (CVE-2013-4242)

* Thu Jun 13 2013 fwang <fwang> 1.5.2-1.mga4
+ Revision: 442314
- new version 1.5.2

* Sat Jan 12 2013 umeabot <umeabot> 1.5.0-3.mga3
+ Revision: 357154
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 15 2011 fwang <fwang> 1.5.0-2.mga2
+ Revision: 181706
- drop .la files
- disable static
- new version 1.5.0

* Sat Jan 08 2011 blino <blino> 1.4.6-4.mga1
+ Revision: 510
- remove obsolete postun
- imported package libgcrypt

